> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hanko.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a new role



## OpenAPI

````yaml openapi-admin post /roles
openapi: 3.0.3
info:
  version: 3.0.4
  title: Hanko Admin API
  description: >
    ## Introduction


    This is the OpenAPI specification for the [Hanko Admin
    API](https://github.com/teamhanko/hanko/blob/main/backend/README.md#start-private-api).


    ## Authentication


    The Admin API must be protected by an access management system.


    ---
  contact:
    email: developers@hanko.io
  license:
    name: AGPL-3.0-or-later
    url: https://www.gnu.org/licenses/agpl-3.0.txt
servers:
  - url: https://{tenant_id}.hanko.io/admin
    variables:
      tenant_id:
        default: ''
        description: The (UU)ID of a tenant. Replace the default value with your tenant ID.
security: []
externalDocs:
  description: More about Hanko
  url: https://github.com/teamhanko/hanko
paths:
  /roles:
    post:
      tags:
        - Role Management
      summary: Create a new role
      operationId: createRole
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                slug:
                  description: >
                    Machine-safe, human-readable identifier for the role.
                    Immutable after creation.

                    Must be non-empty (after trimming whitespace), at most 255
                    characters, contain

                    only lowercase letters, numbers and hyphens (e.g. `admin`,
                    `billing-manager`),

                    and must not be a valid UUID.
                  type: string
                  maxLength: 255
                  pattern: ^[a-z0-9]+(?:-[a-z0-9]+)*$
                name:
                  description: >
                    Display name of the new role. Must be non-empty (after
                    trimming whitespace)

                    and at most 255 characters.
                  type: string
                  maxLength: 255
              required:
                - slug
                - name
      responses:
        '200':
          description: Details of the newly created role
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Role'
        '400':
          $ref: '#/components/responses/BadRequest'
        '409':
          $ref: '#/components/responses/Conflict'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - BearerApiKeyAuth: []
components:
  schemas:
    Role:
      type: object
      required:
        - id
        - slug
        - name
        - created_at
        - updated_at
      properties:
        id:
          description: The ID of the role
          allOf:
            - $ref: '#/components/schemas/UUID4'
        slug:
          description: >-
            Machine-safe, human-readable identifier for the role. Immutable
            after creation.
          type: string
        name:
          description: Display name of the role
          type: string
        created_at:
          description: Time of creation of the role
          type: string
          format: date-time
        updated_at:
          description: Time of last update of the role
          type: string
          format: date-time
    UUID4:
      type: string
      format: uuid4
      example: c339547d-e17d-4ba7-8a1d-b3d5a4d17c1c
    Error:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
  responses:
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 400
            message: Bad Request
    Conflict:
      description: Conflict
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 409
            message: Conflict
    InternalServerError:
      description: Internal server error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
          example:
            code: 500
            message: Internal Server Error
  securitySchemes:
    BearerApiKeyAuth:
      description: >-
        Bearer authentication header of the form `Bearer <token>`, where
        `<token>` is your API key. Must only be used when using Hanko Cloud.
      type: http
      scheme: bearer
      bearerFormat: API Key

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.